//!
//! @file init.c,v
//!
//! Copyright (c) 2006 Atmel.
//!
//! @brief Ӌ@\̏
//!
//! @version 1.4
//!

//_____ ݸٰ _______________________________________________________________
#include "config.h"
#include "inavr.h"
#include "lib_mcu/comparator/comparator_drv.h"

/**
* @brief ߰ĕ`ԐݒA/0`ԐݒAPLLsA荞݋
*/
void init(void)
{
  /***************************************************************************/
  /*		߰ĕ`Ԑݒ												 */
  /***************************************************************************/

  DDRB = 0xC3;
//  DDRC = 0x89;		//MC200
  DDRC = 0x8A;		//MC100
  DDRD = 0x01;
//  DDRE = 0x02;		//MC200
  DDRE = 0x04;		// MC100

  PORTC = 0x06;		/* ٱߋ */

  /***************************************************************************/
  /*		/9`Ԑݒ : ̎g								 */
  /***************************************************************************/
  TCCR0A = (1<<WGM01);		// rv/(CTC)
  TCCR0B = (1<<CS02);		// f_quartz=8MHz/256=32kHz
//  OCR0A = 0x20;			// 8MHz1.056ms1̊荞
//  OCR0A = 0x10;			// 8MHz0.544ms1̊荞
//  OCR0A = 0x08;			// 8MHz0.288ms(16MHz0.144ms)1̊荞
  OCR0A = 0x02;				// 16MHz48s1̊荞
//  OCR0A = 0x03;			// 16MHz64s1̊荞

  TIMSK0 = (1<<OCIE0A);		// rv荞݋

  init_comparator0();
  init_comparator1();
  init_comparator2();

// O݋ /* MC200 */

//  EICRA =(0<<ISC21)|(1<<ISC20)|(0<<ISC11)|(1<<ISC10)|(0<<ISC01)|(1<<ISC00);
//  EIFR = (1<<INTF2)|(1<<INTF1)|(1<<INTF0);	// `Ԑݒ̂߂ɗL蓾銄荞݂
//  EIMSK=(0<<INT2)|(1<<INT1)|(1<<INT0);

  Enable_interrupt();		// S̊荞݋
}
