//!
//! @file mc_interface.c,v
//!
//! Copyright (c) 2006 Atmel.
//!
//! @brief {͓d@p̍ʊ֐񋟂܂B
//!
//! @version 1.4
//!

//_____ ݸٰ _______________________________________________________________
#include "config.h"
#include "mc_interface.h"
#include "mc_control.h"
#include "mc_drv.h"

//_____ ϸ ___________________________________________________________________

//_____ ` __________________________________________________________________
void   svpwm_init(void);
void   Do_Sensor_Interrupt(void);
void   PSC_Start(void);

//_____ 錾 __________________________________________________________________
Bool mci_direction			= CW;		//!< d@ݒ肷邽߂̎gpғҰ
volatile Bool mci_run_stop	= STOP;		//!< d@Jn܂͒~邽߂̎gpғҰ
volatile S16 User_Speed		= 0;		//!< d@xݒ肷邽߂̎gpғҰ

U8 mci_measured_speed		= 0;		//!< d@x𓾂邽߂̓d@Ұ
U32 mci_measured_current	= 0;		//!< d@d𓾂邽߂̓d@Ұ
U8 mci_potentiometer_value	= 0;		//!< d@xݒ肷邽߂̓d@Ұ

//! @brief	̊֐͓d@ߒlԂ܂B
//!
//! @param	Ȃ
//! @pre	ʰ޳ƿĳ̏
//! @return	Ȃ
//! @post	d@Ă邩ۂm܂B
//!/
Bool mci_motor_is_running(void)
{
  return mci_run_stop;
}

//! @brief	xݒ_i[
//!
//! @param	x
//! @pre	Ȃ
//! @return	Ȃ
//!/
void mci_set_speed(U16 speed)
{
  User_Speed = speed;
}

/*
* @brief	ύX
* @pre		d@̏
* @post		̐Vl
*/
void mci_set_direction(U8 direction)
{
  mci_direction = direction;
}

/*
* @brief	v(CW)ŕݒ
* @pre		d@̏
* @post		̐Vl
*/
void mci_forward(void)
{
  mci_direction = CW;
}

/*
* @brief	v(CCW)ŕݒ
* @pre		d@̏
* @post		̐Vl
*/
void mci_backward(void)
{
  mci_direction = CCW;
}

/*
* @brief	
* @pre		d@̏
* @post		l
*/
U8 mci_get_direction(void)
{
  return mci_direction;
}

/**
 * @brief	xݒ(p)
 * @pre		Ȃ
 * @post	ꂽmc_measured_speed
*/
void mci_store_measured_speed(U8 measured_speed)
{
  mci_measured_speed = measured_speed;
}

/**
 * @brief	x
 * @return	x(8ޯ)lԂB
 * @pre		Ȃ
 * @post	Ȃ
*/
U8 mci_get_measured_speed(void)
{
  return mci_measured_speed;
}

/**
* @brief	d@d擾
* @pre		A/Dϊv敔Jn
*
*/
U16 mci_get_measured_current(void)
{
  return (U16)(11*(mci_measured_current/128));
}

/**
* @brief	̂߂'mc_measured_current'ϐݒ
* @pre		Ȃ
* @post		currentl'mc_measured_current'ݒ
*/
void mci_store_measured_current(U16 current)
{
  mci_measured_current = (127 * mci_measured_current + 128*current)/128;
}

/**
* @brief	mci_run͗\ߒ`ꂽҰœd@𓮂܂B
* @param
* @pre		ʰ޳ƿĳ̏
* @post		ΰٕϐɐVl
*/
void mci_run(void)
{
  mci_run_stop = RUN;
  Disable_interrupt();
  svpwm_init();
  Do_Sensor_Interrupt();
  Enable_interrupt();
  PSC_Start();
}

/**
* @brief	̊֐͓d@~܂B
* @param	Ȃ
* @pre		Ȃ
* @post		Ȃ
*/
void mci_stop(void)
{
  PSC_Stop();
  mci_run_stop = STOP;
}
