//! @file psc_drv.h,v
//!
//! Copyright (c) 2004 Atmel.
//!
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قPSCgp̂߂̉ϸۂƒ`܂݂܂B
//!
//! @version 1.7 mc100_bldc_sinus_0_0_5
//!
//! @todo
//! @bug

#ifndef PSC_DRV_H
#define PSC_DRV_H

//_____ ݸٰ _______________________________________________________________
#include "lib_mcu/pll/pll_drv.h"

//! @defgroup PSC_module PSC
//! PSC
//! @{

//_____ ϸ ___________________________________________________________________

  //! @defgroup PSC0_macros PSC0ϸ
  //! PSC0ϸ
  //! @{

	//! @defgroup PSC0_output_configuration PSC0o͌`Ԑݒ
	//! PSC0o͑I
	//! @{
#define Enable_pscout00()					(PSOC0 |=  (1<<POEN0A) )					//!< PSC0g`A
#define Disable_pscout00()					(PSOC0 &= ~(1<<POEN0A) )					//!< PSC0g`A֎~
#define Enable_pscout01()					(PSOC0 |=  (1<<POEN0B) )					//!< PSC0g`B
#define Disable_pscout01()					(PSOC0 &= ~(1<<POEN0B) )					//!< PSC0g`A֎~
#define Enable_both_psc0_outputs()			(PSOC0 |=  ((1<<POEN0A) | (1<<POEN0B)))		//! PSC0g`AB
#define Disable_both_psc0_outputs()			(PSOC0 &= ~((1<<POEN0A) | (1<<POEN0B)))		//! PSC0g`AB֎~

#define Psc0_outputs_active_high()			(PCNF0 |=  (1<<POP0) )						//!< PSC0o͂Low
#define Psc0_outputs_active_low()			(PCNF0 &= ~(1<<POP0) )						//!< PSC0o͂High
	//! @}

	//! @defgroup SPC0_mode_control_module PSC0`Ԑݒ
	//! PSC0`Ԑݒ
	//! @{
#define Enable_psc0_fifty_percent_mode()	(PCNF0 |=  (1<<PFIFTY0) )	//!< PSC050%`: OCR0RBH/LOCR0SBH/LgpBOCR0BH/L̍XVOCR0R/SAH/L2d܂B
#define Disable_psc0_fifty_percent_mode()	(PCNF0 &= ~(1<<PFIFTY0) )	//!< OCR0R/SAH/LOCR0R/SBH/L͊SɓƗłB

#define Enable_psc0_autolock_mode()			(PCNF0 |=  (1<<PALOCK0) )	//!< OCR0R/SAH/LOCR0R/SBH/LPSC𗐂ɏ܂BOCR0RBŌɏꂽꍇAڼ޽̍XVPSC̍Ōŏ܂B
#define Disable_psc0_autolock_mode()		(PCNF0 &= ~(1<<PALOCK0) )	//!< XVPLOCK0ޯĂɏ]ď܂B

#define Lock_psc0_compare_values()			(PCNF0 |=  (1<<PLOCK0) )	//!< Œ艻`Ԃ֎~ꍇɂŒ艻ɂȂ邱ƂɒӂĂB
#define Update_psc0_compare_values()		(PCNF0 &= ~(1<<PLOCK0) )	//!< rڼ޽OCR0ARH/LOCR0BRH̓eōXV܂B
	//! @}

	//! @defgroup PSC0_clock_control PSC0ۯ
	//! PSC0ۯ
	//! @{

	  //! @defgroup PSC0_clock_selection PSC0ۯI
	  //! PSC0ۯI
	  //! @{
#define Psc0_use_pll_clock()				(PCNF0 |= (1<<PCLKSEL0) )										//! PSC0ۯ͂PLLɐڑ
#define Psc0_use_io_clock()					(PCNF0 &= ~(1<<PCLKSEL0) )										//! PSC0ۯ͂I/Oۯɐڑ
#define Psc0_use_64_mega_pll_clock()		(Start_pll_64_mega(),Wait_pll_ready(),Psc0_use_pll_clock() )	//! 64MHzPLLnAPSC0ɐڑ
#define Psc0_use_32_mega_pll_clock()        (Start_pll_32_mega(),Wait_pll_ready(),Psc0_use_pll_clock() )	//! 32MHzPLLnAPSC0ɐڑ
  //! @}

	  //! @defgroup PSC0_prescaler_control PSC0Ou퐧
	  //! PSC0Ou퐧
	  //! @{
#define Disable_psc0_prescaler()			(PCTL0 &= ~(  (1<<PPRE01) | (1<<PPRE00) ) )			//! PSC0OuȂ
#define Divide_psc0_input_clock_by_4()		(PCTL0 &= ~(1<<PPRE01), PCTL0 |=  (1<<PPRE00) )		//! PSC0ۯ͓I4
#define Divide_psc0_input_clock_by_16()		(PCTL0 |=  (1<<PPRE01), PCTL0 &= ~(1<<PPRE00) )		//! PSC0ۯ͓I16
#define Divide_psc0_input_clock_by_64()		(PCTL0 |=  ((1<<PPRE01) | (1<<PPRE00)) )			//! PSC0ۯ͓I64
	  //! @}
	//! @}

	//! @defgroup PSC0_ramp_mode_selection PSC0XΌ`ԑI
	//! PSC0XΌ`ԑI
	//! @{
#define Psc0_in_1_ramp_mode()				(PCNF0 &= ~(  (1<<PMODE01) | (1<<PMODE00) ) )		//! PSC01XΌ`Ԃɐݒ肳A͓v킪0OCR0RB܂Ōv邱ƂӖ܂B
#define Psc0_in_2_ramps_mode()				(PCNF0 &= ~(1<<PMODE01), PCNF0 |=  (1<<PMODE00) )	//! PSC02XΌ`Ԃɐݒ肳A͓v킪0`OCR0RA0`OCR0RB܂Ōv邱ƂӖ܂B
#define Psc0_in_4_ramps_mode()				(PCNF0 |=  (1<<PMODE01), PCNF0 &= ~(1<<PMODE00) )	//! PSC04XΌ`Ԃɐݒ肳A͓v킪0`OCR0SAA0`OCR0RAA0`OCR0SBA0`OCR0RB܂Ōv邱ƂӖ܂B
#define Psc0_in_centered_aligned_mode()		(PCNF0 |=  (  (1<<PMODE01) | (1<<PMODE00) ) )		//! PSC0͒`Ԃɐݒ肳A͓v킪0`OCR0RB܂ŏ㏸OCR0RB`0܂ŉ~v邱ƂӖ܂B
	//! @}

	//! @defgroup PSC0_flank_width_modulation_configuration PSC0ϒ`Ԑݒ
	//! PSC0ϒ`ԐݒI
	//! @{
#define Psc0_symetrical_flank_width_modulation()	(PCTL0 |=  (1<<PBFM0) )		//!< PSC0ϒOCR0RAOCR0RB̗œ܂B
#define Psc0_end_of_cycle_flank_width_modulation()	(PCTL0 &= ~(1<<PBFM0) )		//!< PSC0ϒOCR0RBœ܂B
	//! @}

	//! @defgroup PSC0_adc_amplifier_trigger_configuration PSC0 A/DϊN`Ԑݒ
	//! A/Dϊ܂͑pPSC0N`ԐݒI
	//! @{
#define Psc0_synchro_on_waveform_generator_a_leading_edge()		(PSCO0 &= ~(  (1<<PSYNC01) | (1<<PSYNC00) ) )		//! PSC0M͔g`A̐s[ADC/ɑ܂B
#define Psc0_synchro_on_waveform_generator_a_trailing_edge()	(PSCO0 &= ~(1<<PSYNC01), PSCO0 |=  (1<<PSYNC00) )	//! PSC0M͔g`Ǎs[ADC/ɑ܂B
#define Psc0_synchro_on_waveform_generator_b_leading_edge()		(PSCO0 |=  (1<<PSYNC01), PSCO0 &= ~(1<<PSYNC00) )	//! PSC0M͔g`B̐s[ADC/ɑ܂B
#define Psc0_synchro_on_waveform_generator_b_trailing_edge()	(PSCO0 |=  (  (1<<PSYNC01) | (1<<PSYNC00) ) )		//! PSC0M͔g`Bs[ADC/ɑ܂B
	//! @}

	//! @defgroup PSC0_run_control PSC0s
	//! PSC0ON/OFF
	//! @{
#define Start_psc0()						(PCTL0 |=  (1<<PRUN0) )							//!< PSC0 ON
#define Stop_psc0()							(PCTL0 &= ~(1<<PRUN0) )							//!< PSC0 OFF
#define Psc0_complete_waveform_and_stop()	(PCTL0 |=  (1<<PCCYC0), PCTL0 &= ~(1<<PRUN0) )	//! ̍ŌPSC0 OFF
#define Is_psc0_started()					(PCTL0 & (1<<PRUN0) )
	//! @}

	//! @defgroup PSC0_fault_mode_configuration PSC0`Ԑݒ
	//! PSC0`Ԑݒ
	//! @{
#define Enable_pscout00_fault_mode()		(PCTL0 |=  (1<<PAOC0A) )	//!< ͂APSCOUT00o͂ɒڍp悤ɑI
#define Disable_pscout00_fault_mode()		(PCTL0 &= ~(1<<PAOC0A) )	//!< PSCOUT00ł̌ċN̊ǗȂ

#define Enable_pscout01_fault_mode()		(PCTL0 |=  (1<<PAOC0B) )	//!< ͂BPSCOUT01o͂ɒڍp悤ɑI
#define Disable_pscout01_fault_mode()		(PCTL0 &= ~(1<<PAOC0B) )	//!< PSCOUT01ł̌ċN̊ǗȂ

#define Enable_psc0_autorun()				(PCTL0 |=  (1<<PARUN0) )	//!< PCTL2ڼ޽PRUN2ݒA܂PCTL2ڼ޽PARUN2PCTL1ڼ޽PRUN1̗̐ݒ肪PSC𓯎ɊJn܂B
#define Disable_psc0_autorun()				(PCTL0 &= ~(1<<PARUN0) )	//!< PSC2PSC0Ԃ̓Ȃ
	//! @}

	//! @defgroup PSC0_interrupt_configuration PSC0荞݌`Ԑݒ
	//! PSC0荞݌`Ԑݒ
	//! @{
#define Enable_psc0_synchro_error_interrupt()		(PIM0 |=  (1<<PSEIE0) )		//!< 荞݂PSEI0׸ނݒ肳鎞ɐ܂B
#define Disable_psc0_synchro_error_interrupt()		(PIM0 &= ~(1<<PSEIE0) )		//!< PSEI0׸ނݒ肳鎞Ɋ荞݂͐܂B

#define Enable_psc0_external_event_a_interrupt()	(PIM0 |=  (1<<PEVE0A) )		//!< AċN/肩̕ߊl𐶐łOۂ荞݂𐶐܂B
#define Disable_psc0_external_event_a_interrupt()	(PIM0 &= ~(1<<PEVE0A) )		//!< AċN/肩̕ߊl𐶐łOۂ͂ǂȊ荞݂𐶐܂B

#define Enable_psc0_external_event_b_interrupt()	(PIM0 |=  (1<<PEVE0B) )		//!< BċN/肩̕ߊl𐶐łOۂ荞݂𐶐܂B
#define Disable_psc0_external_event_b_interrupt()	(PIM0 &= ~(1<<PEVE0B) )		//!< BċN/肩̕ߊl𐶐łOۂ͂ǂȊ荞݂𐶐܂B

#define Enable_psc0_end_of_cycle_interrupt()		(PIM0 |=  (1<<PEOPE0) )		//!< PSC0SȎ̍ŌɒBɊ荞݂܂B
#define Disable_psc0_end_of_cycle_interrupt()		(PIM0 &= ~(1<<PEOPE0) )		//!< PSC0SȎ̍ŌɒBɊ荞݂͐܂B
	//! @}

	//! @defgroup PSC0_interrupt_flag_control PSC0荞ݗv׸ސ
	//! PSC0荞ݗv׸ސ
	//! @{
#define Is_psc0_synchro_error_interrupt_flag_set()		(PIFR0 & (1<<PSEI0) )		//!< PIFR0PSEI0׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc0_synchro_error_interrupt_flag()		(PIFR0 &= ~(1<<PSEI0) )		//!< PIFR0PSEI0׸ނ(0)܂B

#define Is_psc0_external_event_a_interrupt_flag_set()	(PIFR0 & (1<<PEV0A) )		//!< PIFR0PEV0A׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc0_external_event_a_interrupt_flag()	(PIFR0 &= ~(1<<PEV0A) )		//!< PIFR0PEV0A׸ނ(0)܂B

#define Is_psc0_external_event_b_interrupt_flag_set()	(PIFR0 & (1<<PEV0B) )		//!< PIFR0PEV0B׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc0_external_event_b_interrupt_flag()	(PIFR0 &= ~(1<<PEV0B) )		//!< PIFR0PEV0B׸ނ(0)܂B

#define Is_psc0_end_of_cycle_interrupt_flag_set()		(PIFR0 & (1<<PEOP2) )		//!< PIFR0PEOP0׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc0_end_of_cycle_interrupt_flag()		(PIFR0 &= ~(1<<PEOP2) )		//!< PIFR0PEOP0׸ނ(0)܂B
	//! @}

	//! @defgroup PSC0_comparison_value_initilization PSC0rl
	//! {͔rl̊Sȏ܂B
	//! @{
//! PSC0Srl
#define Init_psc0_all_compare_values(PSC0_DEADTIME0, PSC0_ONTIME0, PSC0_DEADTIME1, PSC0_ONTIME1) \
	(OCR0SAH = HIGH((U16)PSC0_DEADTIME0),	\
	 OCR0SAL = LOW ((U16)PSC0_DEADTIME0),	\
	 OCR0RAH = HIGH((U16)PSC0_ONTIME0),		\
	 OCR0RAL = LOW ((U16)PSC0_ONTIME0),		\
	 OCR0SBH = HIGH((U16)PSC0_DEADTIME1),	\
	 OCR0SBL = LOW ((U16)PSC0_DEADTIME1),	\
	 OCR0RBH = HIGH((U16)PSC0_ONTIME1),		\
	 OCR0RBL = LOW ((U16)PSC0_ONTIME1)   )
//! PSC0 50%rl(50%`ԂɗLp)
#define Init_psc0_fifty_percent_compare_values(PSC0_DEADTIME1, PSC0_ONTIME1) \
	(OCR0SBH = HIGH((U16)PSC0_DEADTIME1),	\
	 OCR0SBL = LOW ((U16)PSC0_DEADTIME1),	\
	 OCR0RBH = HIGH((U16)PSC0_ONTIME1),		\
	 OCR0RBL = LOW ((U16)PSC0_ONTIME1)   )
	//! @}
  //! @}

  //! @defgroup PSC1_macros PSC1ϸ
  //! PSC1ϸ
  //! @{

	//! @defgroup PSC1_output_configuration PSC1o͌`Ԑݒ
	//! PSC1o͑I
	//! @{
#define Enable_pscout10()					(PSOC1 |=  (1<<POEN1A) )					//!< PSC1g`A
#define Disable_pscout10()					(PSOC1 &= ~(1<<POEN1A) )					//!< PSC1g`A֎~
#define Enable_pscout11()					(PSOC1 |=  (1<<POEN1B) )					//!< PSC1g`B
#define Disable_pscout11()					(PSOC1 &= ~(1<<POEN1B) )					//!< PSC1g`B֎~
#define Enable_both_psc1_outputs()			(PSOC1 |=  ((1<<POEN1A) | (1<<POEN1B)))		//! PSC1g`AB
#define Disable_both_psc1_outputs()			(PSOC1 &= ~((1<<POEN1A) | (1<<POEN1B)))		//! PSC1g`AB֎~

#define Psc1_outputs_active_high()			(PCNF1 |=  (1<<POP1) )						//!< PSC1o͂Low
#define Psc1_outputs_active_low()			(PCNF1 &= ~(1<<POP1) )						//!< PSC1o͂High
	//! @}

	//! @defgroup PSC1_mode_control_module PSC1`Ԑݒ
	//! PSC1`Ԑݒ
	//! @{
#define Enable_psc1_fifty_percent_mode()	(PCNF1 |=  (1<<PFIFTY1) )	//!< PSC150%`: OCR1RBH/LOCR1SBH/LgpBOCR1BH/L̍XVOCR1R/SAH/L2d܂B
#define Disable_psc1_fifty_percent_mode()	(PCNF1 &= ~(1<<PFIFTY1) )	//!< OCR1R/SAH/LOCR1R/SBH/L͊SɓƗłB

#define Enable_psc1_autolock_mode()			(PCNF1 |=  (1<<PALOCK1) )	//!< OCR1R/SAH/LOCR1R/SBH/LPSC𗐂ɏ܂BOCR1RBŌɏꂽꍇAڼ޽̍XVPSC̍Ōŏ܂B
#define Disable_psc1_autolock_mode()		(PCNF1 &= ~(1<<PALOCK1) )	//!< XVPLOCK1ޯĂɏ]ď܂B

#define Lock_psc1_compare_values()			(PCNF1 |=  (1<<PLOCK1) )	//!< Œ艻`Ԃ֎~ꍇɂŒ艻ɂȂ邱ƂɒӂĂB
#define Update_psc1_compare_values()		(PCNF1 &= ~(1<<PLOCK1) )	//!< rڼ޽OCR1ARH/LOCR1BRH̓eōXV܂B
	//! @}

	//! @defgroup PSC1_clock_control PSC1ۯ
	//! PSC1ۯ
	//! @{

	  //! @defgroup PSC1_clock_selection PSC1ۯI
	  //! PSC1ۯI
	  //! @{
#define Psc1_use_pll_clock()				(PCNF1 |= (1<<PCLKSEL0) )										//! PSC1ۯ͂PLLɐڑ
#define Psc1_use_io_clock()					(PCNF1 &= ~(1<<PCLKSEL0) )										//! PSC1ۯ͂I/Oۯɐڑ
#define Psc1_use_64_mega_pll_clock()		(Start_pll_64_mega(),Wait_pll_ready(),Psc1_use_pll_clock() )	//! 64MHzPLLnAPSC1ɐڑ
#define Psc1_use_32_mega_pll_clock()		(Start_pll_32_mega(),Wait_pll_ready(),Psc1_use_pll_clock() )	//! 32MHzPLLnAPSC1ɐڑ
	  //! @}

	  //! @defgroup PSC1_prescaler_control PSC1Ou퐧
	  //! PSC1Ou퐧
	  //! @{
#define Disable_psc1_prescaler()			(PCTL1 &= ~(  (1<<PPRE11) | (1<<PPRE10) ) )			//! PSC1OuȂ
#define Divide_psc1_input_clock_by_4()		(PCTL1 &= ~(1<<PPRE11), PCTL1 |=  (1<<PPRE10) )		//! PSC1ۯ͓I4
#define Divide_psc1_input_clock_by_16()		(PCTL1 |=  (1<<PPRE11), PCTL1 &= ~(1<<PPRE10) )		//! PSC1ۯ͓I16
#define Divide_psc1_input_clock_by_64()		(PCTL1 |=  ((1<<PPRE11) | (1<<PPRE10)) )			//! PSC1ۯ͓I64
	  //! @}
	//! @}

	//! @defgroup PSC1_ramp_mode_selection PSC1XΌ`ԑI
	//! PSC1XΌ`ԑI
	//! @{
#define Psc1_in_1_ramp_mode()				(PCNF1 &= ~(  (1<<PMODE11) | (1<<PMODE10) ) )		//! PSC11XΌ`Ԃɐݒ肳A͓v킪0OCR1RB܂Ōv邱ƂӖ܂B
#define Psc1_in_2_ramps_mode()				(PCNF1 &= ~(1<<PMODE11), PCNF1 |=  (1<<PMODE10) )	//! PSC12XΌ`Ԃɐݒ肳A͓v킪0`OCR1RA0`OCR1RB܂Ōv邱ƂӖ܂B
#define Psc1_in_4_ramps_mode()				(PCNF1 |=  (1<<PMODE11), PCNF1 &= ~(1<<PMODE10) )	//! PSC14XΌ`Ԃɐݒ肳A͓v킪0`OCR1SAA0`OCR1RAA0`OCR1SBA0`OCR1RB܂Ōv邱ƂӖ܂B
#define Psc1_in_centered_aligned_mode()		(PCNF1 |=  (  (1<<PMODE11) | (1<<PMODE10) ) )		//! PSC1͒`Ԃɐݒ肳A͓v킪0`OCR1RB܂ŏ㏸OCR1RB`0܂ŉ~v邱ƂӖ܂B
	//! @}

	//! @defgroup PSC1_flank_width_modulation_configuration PSC1ϒ`Ԑݒ
	//! PSC1ϒ`ԐݒI
	//! @{
#define Psc1_symetrical_flank_width_modulation()	(PCTL1 |=  (1<<PBFM1) )		//!< PSC1ϒOCR1RAOCR1RB̗œ܂B
#define Psc1_end_of_cycle_flank_width_modulation()	(PCTL1 &= ~(1<<PBFM1) )		//!< PSC1ϒOCR1RBœ܂B
	//! @}

	//! @defgroup PSC1_adc_amplifier_trigger_configuration PSC1 A/DϊN`Ԑݒ
	//! A/Dϊ܂͑pPSC1N`ԐݒI
	//! @{
#define Psc1_synchro_on_waveform_generator_a_leading_edge()		(PSCO1 &= ~(  (1<<PSYNC11) | (1<<PSYNC10) ) )		//! PSC1M͔g`A̐s[ADC/ɑ܂B
#define Psc1_synchro_on_waveform_generator_a_trailing_edge()	(PSCO1 &= ~(1<<PSYNC11), PSCO1 |=  (1<<PSYNC10) )	//! PSC1M͔g`Ǎs[ADC/ɑ܂B
#define Psc1_synchro_on_waveform_generator_b_leading_edge()		(PSCO1 |=  (1<<PSYNC11), PSCO1 &= ~(1<<PSYNC10) )	//! PSC1M͔g`B̐s[ADC/ɑ܂B
#define Psc1_synchro_on_waveform_generator_b_trailing_edge()	(PSCO1 |=  (  (1<<PSYNC11) | (1<<PSYNC10) ) )		//! PSC0M͔g`B̌s[ADC/ɑ܂B
	//! @}

	//! @defgroup PSC1_run_control PSC1s
	//! PSC1ON/OFF
	//! @{
#define Start_psc1()						(PCTL1 |=  (1<<PRUN1) )							//!< PSC1 ON
#define Stop_psc1()							(PCTL1 &= ~(1<<PRUN1) )							//!< PSC1 OFF
#define Psc1_complete_waveform_and_stop()	(PCTL1 |=  (1<<PCCYC1), PCTL1 &= ~(1<<PRUN1) )	//! ̍ŌPSC1 OFF
#define Is_psc1_started()					(PCTL1 & (1<<PRUN1) )
	//! @}

	//! @defgroup PSC1_fault_mode_configuration PSC1`Ԑݒ
	//! PSC1`Ԑݒ
	//! @{
#define Enable_pscout10_fault_mode()		(PCTL1 |=  (1<<PAOC1A) )	//!< ͂APSCOUT10o͂ɒڍp悤ɑI
#define Disable_pscout10_fault_mode()		(PCTL1 &= ~(1<<PAOC1A) )	//!< PSCOUT10ł̌ċN̊ǗȂ

#define Enable_pscout11_fault_mode()		(PCTL1 |=  (1<<PAOC1B) )	//!< ͂BPSCOUT11o͂ɒڍp悤ɑI
#define Disable_pscout11_fault_mode()		(PCTL1 &= ~(1<<PAOC1B) )	//!< PSCOUT11ł̌ċN̊ǗȂ

#define Enable_psc1_autorun()				(PCTL1 |=  (1<<PARUN1) )	//!< PCTL0ڼ޽PRUN0ݒA܂PCTL0ڼ޽PARUN0PCTL2ڼ޽PRUN2̗̐ݒ肪PSC𓯎ɊJn܂B
#define Disable_psc1_autorun()				(PCTL1 &= ~(1<<PARUN1) )	//!< PSC2PSC1Ԃ̓Ȃ
	//! @}

	//! @defgroup PSC1_interrupt_configuration PSC1荞݌`Ԑݒ
	//! PSC1荞݌`Ԑݒ
	//! @{
#define Enable_psc1_synchro_error_interrupt()		(PIM1 |=  (1<<PSEIE1) )		//!< 荞݂PSEI1׸ނݒ肳鎞ɐ܂B
#define Disable_psc1_synchro_error_interrupt()		(PIM1 &= ~(1<<PSEIE1) )		//!< PSEI1׸ނݒ肳鎞Ɋ荞݂͐܂B

#define Enable_psc1_external_event_a_interrupt()	(PIM1 |=  (1<<PEVE1A) )		//!< AċN/肩̕ߊl𐶐łOۂ荞݂𐶐܂B
#define Disable_psc1_external_event_a_interrupt()	(PIM1 &= ~(1<<PEVE1A) )		//!< AċN/肩̕ߊl𐶐łOۂ͂ǂȊ荞݂𐶐܂B

#define Enable_psc1_external_event_b_interrupt()	(PIM1 |=  (1<<PEVE1B) )		//!< BċN/肩̕ߊl𐶐łOۂ荞݂𐶐܂B
#define Disable_psc1_external_event_b_interrupt()	(PIM1 &= ~(1<<PEVE1B) )		//!< BċN/肩̕ߊl𐶐łOۂ͂ǂȊ荞݂𐶐܂B

#define Enable_psc1_end_of_cycle_interrupt()		(PIM1 |=  (1<<PEVE1A) )		//!< PSC1SȎ̍ŌɒBɊ荞݂܂B
#define Disable_psc1_end_of_cycle_interrupt()		(PIM1 &= ~(1<<PEVE1A) )		//!< PSC1SȎ̍ŌɒBɊ荞݂͐܂B
	//! @}

	//! @defgroup PSC1_interrupt_flag_control PSC1荞ݗv׸ސ
	//! PSC1荞ݗv׸ސ
	//! @{
#define Is_psc1_synchro_error_interrupt_flag_set()		(PIFR1 & (1<<PSEI0) )		//!< PIFR1PSEI1׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc1_synchro_error_interrupt_flag()		(PIFR1 &= ~(1<<PSEI0) )		//!< PIFR1PSEI1׸ނ(0)܂B

#define Is_psc1_external_event_a_interrupt_flag_set()	(PIFR1 & (1<<PEV0A) )		//!< PIFR1PEV1A׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc1_external_event_a_interrupt_flag()	(PIFR1 &= ~(1<<PEV0A) )		//!< PIFR1PEV1A׸ނ(0)܂B

#define Is_psc1_external_event_b_interrupt_flag_set()	(PIFR1 & (1<<PEV0B) )		//!< PIFR1PEV1B׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc1_external_event_b_interrupt_flag()	(PIFR1 &= ~(1<<PEV0B) )		//!< PIFR1PEV1B׸ނ(0)܂B

#define Is_psc1_end_of_cycle_interrupt_flag_set()		(PIFR1 & (1<<PEOP1) )		//!< PIFR1PEOP1׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc1_end_of_cycle_interrupt_flag()		(PIFR1 &= ~(1<<PEOP1) )		//!< PIFR1PEOP1׸ނ(0)܂B
	//! @}

	//! @defgroup PSC1_comparison_value_initilization PSC1rl
	//! {͔rl̊Sȏ܂B
	//! @{
//! PSC1Srl
#define Init_psc1_all_compare_values(PSC1_DEADTIME0, PSC1_ONTIME0, PSC1_DEADTIME1, PSC1_ONTIME1) \
	(OCR1SAH = HIGH((U16)PSC1_DEADTIME0),	\
	 OCR1SAL = LOW ((U16)PSC1_DEADTIME0),	\
	 OCR1RAH = HIGH((U16)PSC1_ONTIME0),		\
	 OCR1RAL = LOW ((U16)PSC1_ONTIME0),		\
	 OCR1SBH = HIGH((U16)PSC1_DEADTIME1),	\
	 OCR1SBL = LOW ((U16)PSC1_DEADTIME1),	\
	 OCR1RBH = HIGH((U16)PSC1_ONTIME1),		\
	 OCR1RBL = LOW ((U16)PSC1_ONTIME1)   )
//! PSC1 50%rl(50%`ԂɗLp)
#define Init_psc1_fifty_percent_compare_values(PSC1_DEADTIME1, PSC1_ONTIME1) \
	(OCR1SBH = HIGH((U16)PSC1_DEADTIME1),	\
	 OCR1SBL = LOW ((U16)PSC1_DEADTIME1),	\
	 OCR1RBH = HIGH((U16)PSC1_ONTIME1),		\
	 OCR1RBL = LOW ((U16)PSC1_ONTIME1)   )
	//! @}
  //! @}

  //! @defgroup PSC2_macros PSC2ϸ
  //! PSC2ϸ
  //! @{

	//! @defgroup PSC2_output_configuration PSC2o͌`Ԑݒ
	//! PSC2o͑I
	//! @{
#define Enable_pscout20()					(PSOC2 |=  (1<<POEN2A) )					//!< PSC2g`A
#define Disable_pscout20()					(PSOC2 &= ~(1<<POEN2A) )					//!< PSC2g`A֎~
#define Enable_pscout21()					(PSOC2 |=  (1<<POEN2B) )					//!< PSC2g`B
#define Disable_pscout21()					(PSOC2 &= ~(1<<POEN2B) )					//!< PSC2g`B֎~
#define Enable_both_psc2_outputs()			(PSOC2 |=  ((1<<POEN2A) | (1<<POEN2B)))		//! PSC2g`AB
#define Disable_both_psc2_outputs()			(PSOC2 &= ~((1<<POEN2A) | (1<<POEN2B)))		//! PSC2g`AB֎~

#define Psc2_outputs_active_high()			(PCNF2 |=  (1<<POP2) )						//!< PSC2o͂Low
#define Psc2_outputs_active_low()			(PCNF2 &= ~(1<<POP2) )						//!< PSC2o͂High
	//! @}

	//! @defgroup PSC2_mode_control_module PSC2`Ԑݒ
	//! PSC2`Ԑݒ
	//! @{
#define Enable_psc2_fifty_percent_mode()	(PCNF2 |=  (1<<PFIFTY2) )	//!< PSC250%`: OCR2RBH/LOCR2SBH/LgpBOCR2BH/L̍XVOCR2R/SAH/L2d܂B
#define Disable_psc2_fifty_percent_mode()	(PCNF2 &= ~(1<<PFIFTY2) )	//!< OCR2R/SAH/LOCR2R/SBH/L͊SɓƗłB

#define Enable_psc2_autolock_mode()			(PCNF2 |=  (1<<PALOCK2) )	//!< OCR2R/SAH/LOCR2R/SBH/LPSC𗐂ɏ܂BOCR2RBŌɏꂽꍇAڼ޽̍XVPSC̍Ōŏ܂B
#define Disable_psc2_autolock_mode()		(PCNF2 &= ~(1<<PALOCK2) )	//!< XVPLOCK2ޯĂɏ]ď܂B

#define Lock_psc2_compare_values()			(PCNF2 |=  (1<<PLOCK2) )	//!< Œ艻`Ԃ֎~ꍇɂŒ艻ɂȂ邱ƂɒӂĂB
#define Update_psc2_compare_values()		(PCNF2 &= ~(1<<PLOCK2) )	//!< rڼ޽OCR2ARH/LOCR2BRH̓eōXV܂B
	//! @}

	//! @defgroup PSC2_clock_control PSC2ۯ
	//! PSC2ۯ
	//! @{

	  //! @defgroup PSC2_clock_selection PSC2ۯI
	  //! PSC2ۯI
	  //! @{
#define Psc2_use_pll_clock()				(PCNF2 |= (1<<PCLKSEL0) )										//! PSC2ۯ͂PLLɐڑ
#define Psc2_use_io_clock()					(PCNF2 &= ~(1<<PCLKSEL0) )										//! PSC2ۯ͂I/Oۯɐڑ
#define Psc2_use_64_mega_pll_clock()		(Start_pll_64_mega(),Wait_pll_ready(),Psc2_use_pll_clock() )	//! 64MHzPLLnAPSC2ɐڑ
#define Psc2_use_32_mega_pll_clock()		(Start_pll_32_mega(),Wait_pll_ready(),Psc2_use_pll_clock() )	//! 32MHzPLLnAPSC2ɐڑ
	  //! @}

	  //! @defgroup PSC2_prescaler_control PSC2Ou퐧
	  //! PSC2Ou퐧
	  //! @{
#define Disable_psc2_prescaler()			(PCTL2 &= ~(  (1<<PPRE21) | (1<<PPRE20) ) )			//! PSC2OuȂ
#define Divide_psc2_input_clock_by_4()		(PCTL2 &= ~(1<<PPRE21), PCTL2 |=  (1<<PPRE20) )		//! PSC2ۯ͓I4
#define Divide_psc2_input_clock_by_16()		(PCTL2 |=  (1<<PPRE21), PCTL2 &= ~(1<<PPRE20) )		//! PSC2ۯ͓I16
#define Divide_psc2_input_clock_by_64()		(PCTL2 |=  ((1<<PPRE21) | (1<<PPRE20)) )			//! PSC2ۯ͓I64
	  //! @}
	//! @}

	//! @defgroup PSC2_ramp_mode_selection PSC2XΌ`ԑI
	//! PSC2XΌ`ԑI
	//! @{
#define Psc2_in_1_ramp_mode()				(PCNF2 &= ~(  (1<<PMODE21) | (1<<PMODE20) ) )		//! PSC21XΌ`Ԃɐݒ肳A͓v킪0OCR2RB܂Ōv邱ƂӖ܂B
#define Psc2_in_2_ramps_mode()				(PCNF2 &= ~(1<<PMODE21), PCNF2 |= (1<<PMODE20) )	//! PSC22XΌ`Ԃɐݒ肳A͓v킪0`OCR2RA0`OCR2RB܂Ōv邱ƂӖ܂B
#define Psc2_in_4_ramps_mode()				(PCNF2 |=  (1<<PMODE21), PCNF2 &= ~(1<<PMODE20) )	//! PSC24XΌ`Ԃɐݒ肳A͓v킪0`OCR2SAA0`OCR2RAA0`OCR2SBA0`OCR2RB܂Ōv邱ƂӖ܂B
#define Psc2_in_centered_aligned_mode()		(PCNF2 |=  (  (1<<PMODE21) | (1<<PMODE20) ) )		//! PSC2͒`Ԃɐݒ肳A͓v킪0`OCR2RB܂ŏ㏸OCR2RB`0܂ŉ~v邱ƂӖ܂B
	//! @}

	//! @defgroup PSC2_flank_width_modulation_configuration PSC2ϒ`Ԑݒ
	//! PSC2ϒ`ԐݒI
	//! @{
#define Psc2_symetrical_flank_width_modulation()	(PCTL2 |=  (1<<PBFM2) )		//!< PSC2ϒOCR2RAOCR2RB̗œ܂B
#define Psc2_end_of_cycle_flank_width_modulation()	(PCTL2 &= ~(1<<PBFM2) )		//!< PSC2ϒOCR2RBœ܂B
	//! @}

	//! @defgroup PSC2_adc_amplifier_trigger_configuration PSC2 A/DϊN`Ԑݒ
	//! A/Dϊ܂͑pPSC2N`ԐݒI
	//! @{
#define Psc2_synchro_on_waveform_generator_a_leading_edge()		(PSCO2  &= ~(  (1<<PSYNC21) | (1<<PSYNC20) ) )		//! PSC2M͔g`A̐s[ADC/ɑ܂B
#define Psc2_synchro_on_waveform_generator_a_trailing_edge()	(PSCO2 &= ~(1<<PSYNC21), PSCO2 |=  (1<<PSYNC20) )	//! PSC2M͔g`Ǎs[ADC/ɑ܂B
#define Psc2_synchro_on_waveform_generator_b_leading_edge()		(PSCO2 |=  (1<<PSYNC21), PSCO2 &= ~(1<<PSYNC20) )	//! PSC2M͔g`B̐s[ADC/ɑ܂B
#define Psc2_synchro_on_waveform_generator_b_trailing_edge()	(PSCO2 |=  (  (1<<PSYNC21) | (1<<PSYNC20) ) )		//! PSC2M͔g`Ǎs[ADC/ɑ܂B
	//! @}

	//! @defgroup PSC2_run_control PSC2s
	//! PSC2ON/OFF
	//! @{
#define Start_psc2()						(PCTL2 |=  (1<<PRUN2) )							//!< PSC2 ON
#define Stop_psc2()							(PCTL2 &= ~(1<<PRUN2) )							//!< PSC2 OFF
#define Psc2_complete_waveform_and_stop()	(PCTL2 |=  (1<<PCCYC2), PCTL2 &= ~(1<<PRUN2) )	//! ̍ŌPSC2 OFF
#define Is_psc2_started()					(PCTL2 & (1<<PRUN2) )
	//! @}

	//! @defgroup PSC2_fault_mode_configuration PSC2`Ԑݒ
	//! PSC2`Ԑݒ
	//! @{
#define Enable_pscout20_fault_mode()		(PCTL2 |=  (1<<PAOC2A) )	//!< ͂APSCOUT20o͂ɒڍp悤ɑI
#define Disable_pscout20_fault_mode()		(PCTL2 &= ~(1<<PAOC2A) )	//!< PSCOUT20ł̌ċN̊ǗȂ

#define Enable_pscout21_fault_mode()		(PCTL2 |=  (1<<PAOC2B) )	//!< ͂BPSCOUT21o͂ɒڍp悤ɑI
#define Disable_pscout21_fault_mode()		(PCTL2 &= ~(1<<PAOC2B) )	//!< PSCOUT21ł̌ċN̊ǗȂ

#define Enable_psc2_autorun()				(PCTL2 |=  (1<<PARUN2) )	//!< PCTL1ڼ޽PRUN1ݒA܂PCTL1ڼ޽PARUN1PCTL0ڼ޽PRUN0̗̐ݒ肪PSC𓯎ɊJn܂B
#define Disable_psc2_autorun()				(PCTL2 &= ~(1<<PARUN2) )	//!< PSC2PSC2Ԃ̓Ȃ
	//! @}

	//! @defgroup PSC2_interrupt_configuration PSC2荞݌`Ԑݒ
	//! PSC2荞݌`Ԑݒ
	//! @{
#define Enable_psc2_synchro_error_interrupt()		(PIM2 |=  (1<<PSEIE2) )		//!< 荞݂PSEI2׸ނݒ肳鎞ɐ܂B
#define Disable_psc2_synchro_error_interrupt()		(PIM2 &= ~(1<<PSEIE2) )		//!< PSEI2׸ނݒ肳鎞Ɋ荞݂͐܂B

#define Enable_psc2_external_event_a_interrupt()	(PIM2 |=  (1<<PEVE2A) )		//!< AċN/肩̕ߊl𐶐łOۂ荞݂𐶐܂B
#define Disable_psc2_external_event_a_interrupt()	(PIM2 &= ~(1<<PEVE2A) )		//!< AċN/肩̕ߊl𐶐łOۂ͂ǂȊ荞݂𐶐܂B

#define Enable_psc2_external_event_b_interrupt()	(PIM2 |=  (1<<PEVE2B) )		//!< BċN/肩̕ߊl𐶐łOۂ荞݂𐶐܂B
#define Disable_psc2_external_event_b_interrupt()	(PIM2 &= ~(1<<PEVE2B) )		//!< BċN/肩̕ߊl𐶐łOۂ͂ǂȊ荞݂𐶐܂B

#define Enable_psc2_end_of_cycle_interrupt()		(PIM2 |=  (1<<PEOPE2) )		//!< PSC2SȎ̍ŌɒBɊ荞݂܂B
#define Disable_psc2_end_of_cycle_interrupt()		(PIM2 &= ~(1<<PEOPE2) )		//!< PSC2SȎ̍ŌɒBɊ荞݂͐܂B
	//! @}

	//! @defgroup PSC2_interrupt_flag_control PSC2荞ݗv׸ސ
	//! PSC2荞ݗv׸ސ
	//! @{
#define Is_psc2_synchro_error_interrupt_flag_set()		(PIFR2 & (1<<PSEI0) )		//!< PIFR2PSEI2׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc2_synchro_error_interrupt_flag()		(PIFR2 &= ~(1<<PSEI0) )		//!< PIFR2PSEI2׸ނ(0)܂B

#define Is_psc2_external_event_a_interrupt_flag_set()	(PIFR2 & (1<<PEV0A) )		//!< PIFR2PEV2A׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc2_external_event_a_interrupt_flag()	(PIFR2 &= ~(1<<PEV0A) )		//!< PIFR2PEV2A׸ނ(0)܂B

#define Is_psc2_external_event_b_interrupt_flag_set()	(PIFR2 & (1<<PEV0B) )		//!< PIFR2PEV2B׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc2_external_event_b_interrupt_flag()	(PIFR2 &= ~(1<<PEV0B) )		//!< PIFR2PEV2B׸ނ(0)܂B

#define Is_psc2_end_of_cycle_interrupt_flag_set()		(PIFR2 & (1<<PEOP2) )		//!< PIFR2PEOP2׸ނݒ(1)Ȃ1Ԃ܂B
#define Clear_psc2_end_of_cycle_interrupt_flag()		(PIFR2 &= ~(1<<PEOP2) )		//!< PIFR2PEOP2׸ނ(0)܂B
	//! @}

	//! @defgroup PSC2_comparison_value_initilization PSC2rl
	//! {͔rl̊Sȏ܂B
	//! @{
//! PSC2Srl
#define Init_psc2_all_compare_values(PSC2_DEADTIME0, PSC2_ONTIME0, PSC2_DEADTIME1, PSC2_ONTIME1) \
	(OCR2SAH = HIGH((U16)PSC2_DEADTIME0),	\
	 OCR2SAL = LOW ((U16)PSC2_DEADTIME0),	\
	 OCR2RAH = HIGH((U16)PSC2_ONTIME0),		\
	 OCR2RAL = LOW ((U16)PSC2_ONTIME0),		\
	 OCR2SBH = HIGH((U16)PSC2_DEADTIME1),	\
	 OCR2SBL = LOW ((U16)PSC2_DEADTIME1),	\
	 OCR2RBH = HIGH((U16)PSC2_ONTIME1),		\
	 OCR2RBL = LOW ((U16)PSC2_ONTIME1)   )
//! PSC2 50%rl(50%`ԂɗLp)
#define Init_psc2_fifty_percent_compare_values(PSC2_DEADTIME1,PSC2_ONTIME1) \
	(OCR2SBH = HIGH((U16)PSC2_DEADTIME1),	\
	 OCR2SBL = LOW ((U16)PSC2_DEADTIME1),	\
	 OCR2RBH = HIGH((U16)PSC2_ONTIME1),		\
	 OCR2RBL = LOW ((U16)PSC2_ONTIME1)   )
  //! @}

//_____ ` __________________________________________________________________
  //! @defgroup PSC_structure_definitions PSC\̒`
  //! ̒`PSC֐ɂĎgpׂłB
  //! @{
typedef struct st_psc_comparison_values {
  U16 deadtime0;
  U16 ontime0;
  U16 deadtime1;
  U16 ontime1;
}Psc_comparison_values;

typedef struct st_psc_fifty_percent_comparison_values {
  U16 deadtime1;
  U16 ontime1;
}Psc_fifty_percent_comparison_values;
  //! @}

//_____ ֐ __________________________________________________________________
  //! @defgroup PSC0_low_level_functions PSC0ʊ֐
  //! {PSC0SɌ`Ԑݒ肵Ė]ޔrlł̊Jn܂B
  //! @{
//! PSC0`Ԑݒl`ɏ]PSC0`Ԑݒ肵APSC0rlĎn܂B
void init_psc0         (void);
//! U16Ƃēn4̒lɏ]PSC0rlSĂXV
void update_psc0       ( Psc_comparison_values *psc0_comparison_values );
//! U16Ƃēn2̒lɏ]PSC0rl̔XV
void update_psc0_fifty ( Psc_fifty_percent_comparison_values *psc0_fifty_percent_comparison_values );
  //! @}

  //! @defgroup PSC1_low_level_functions PSC1ʊ֐
  //! {PSC1SɌ`Ԑݒ肵Ė]ޔrlł̊Jn܂B
  //! @{
//! PSC1`Ԑݒl`ɏ]PSC1`Ԑݒ肵APSC1rlĎn܂B
void init_psc1         (void);
//! U16Ƃēn4̒lɏ]PSC1rlSĂXV
void update_psc1       ( Psc_comparison_values *psc1_comparison_values );
//! U16Ƃēn2̒lɏ]PSC1rl̔XV
void update_psc1_fifty ( Psc_fifty_percent_comparison_values *psc1_fifty_percent_comparison_values );
  //! @}

  //! @defgroup PSC2_low_level_functions PSC2ʊ֐
  //! {PSC2SɌ`Ԑݒ肵Ė]ޔrlł̊Jn܂B
  //! @{
//! PSC2`Ԑݒl`ɏ]PSC2`Ԑݒ肵APSC2rlĎn܂B
void init_psc2         (void);
//! U16Ƃēn4̒lɏ]PSC2rlSĂXV
void update_psc2       ( Psc_comparison_values *psc2_comparison_values );
//! U16Ƃēn2̒lɏ]PSC2rl̔XV
void update_psc2_fifty ( Psc_fifty_percent_comparison_values *psc2_fifty_percent_comparison_values );
  //! @}
//! @}
#endif  // PSC_DRV_H
